program winsock_interface;


uses  winsock, wincrt, strings;

var
s          : integer;
temp       : string[10];
hostname   : string[255];
portnumber : integer;
MTU_MAX    : integer;

function Server_Send(s : integer; message : string): integer;
var status : integer;
begin
    status := send(s,PChar(@message[1]), Length(message),0);
    if (status < 0)  then
    begin
      writeln('Unable to send ',message, ' to socket ', s);
      WSACleanup;
      halt;
    end;
    Server_Send := status;
end;

function Server_Receive(s : integer): string;
var
 len : integer;
 message : string;
begin
 len := recv(s, PChar(@message[1]), 255,0);
 message[0] := char(len);
 if (len = 0) then
 begin
   writeln('Socket lost...');
   WSACleanup;
   halt;
 end;
 Server_receive := message;
end;

function Server_Disconnect(s : integer) : integer;
begin
  WSACleanup;
  writeln('Cleanup completed for socket ',s,'...');
  halt;
end;

function open_client(hostname : string; portnumber : integer): integer;
var
  phe	  : PHostEnt;
  pa	  : PChar;
  sz      : array [1..64] of char;
  sa	  : in_addr;
  FSocket : integer;
  e       : integer; { reusable }

  ps	: PServEnt;
  proto	: array [1..32] of char;
  name : array [1..64] of char;
  portn : array [1..32] of char;
  myVerReqd : word;
  myWSAData : WSADATA;

  peeraddr_in : sockaddr_in;
  dummy : Psockaddr;

begin
        myVerReqd:=$0101;
        peeraddr_in.sin_family := PF_INET;
       {	peeraddr_in.sin_addr.s_addr := INADDR_ANY;   }
        peeraddr_in.sin_port := 0;

	if( WSAStartup(myVerReqd,@myWSAData) <> 0) then
        begin
		writeln('Can''t startup WinSock');
                halt;
        end;
        writeln('Gethostbyname=',hostname);
	StrPCopy(@sz, hostname);
	phe := gethostbyname(@sz);
	if phe <> nil then
	begin
	  pa := phe^.h_addr_list^;
	  sa.S_un_b.s_b1:=pa[0];
	  sa.S_un_b.s_b2:=pa[1];
	  sa.S_un_b.s_b3:=pa[2];
	  sa.S_un_b.s_b4:=pa[3];
          peeraddr_in.sin_addr := sa;
       end
 else
   writeln('Can''t find host ' + hostname);

   if (portnumber = 0) then
   begin
	StrPCopy(@proto, 'tcp');
	StrPCopy(@name, '127.0.0.1');
	ps := getservbyname(@name, @proto);
	if ps <> nil then
		peeraddr_in.sin_port := htons(ps^.s_port)
	else
		peeraddr_in.sin_port := htons(portnumber);
   end
   else
       peeraddr_in.sin_port := htons(portnumber);

   FSocket := _socket(AF_INET,SOCK_STREAM,0);
   if (FSocket = 0) then
   begin
     writeln('Unable to create socket.');
     WSACleanup;
     halt;
   end;

   if connect(FSocket, PSockAddr(@peeraddr_in)^, SizeOf(peeraddr_in)) <> 0 then
     if WSAGetLastError <> WSAEWOULDBLOCK then
     begin
          e := WSAGetLastError;
	  if FSocket <> INVALID_SOCKET then
	    WSACleanup;
	  writeln('Connect failed... Error=',e, ' Socket=',FSocket);
     end;



    open_client := FSocket;
end;

function do_keyboard(s : integer): integer;
var
  rmessage : string;
  smessage : string;
  count : integer;
  time  : timeval;
  myset : fd_set;
  xxset : fd_set;
  xset  : integer;
{
  	fd_set = record
		fd_count : u_short;
		fd_array : array[0..FD_SETSIZE-1] of TSock;
	end;
        }

begin
  count := 0;
  time.tv_sec := 1;
  time.tv_usec := 0;

   while (1<>2) do
   begin
    xxset.fd_count := 0;
    myset.fd_count := 1;
    myset.fd_array[0] := s;
    myset.fd_array[1] := s;
    xset := select(1,myset,xxset,xxset,time);
    case xset of
    -1 :
         begin
           writeln('XSET ERROR=',xset);
           WSACleanup;
           halt;
          end;
     1 :
         begin
            rmessage := Server_receive(s);
            if (length(rmessage) > 0) then write(rmessage);
         end;
     0 :
          begin
            if (keypressed) then
            begin
              readln(smessage);
              if length(smessage) > 0 then Server_send(s,smessage+#13+#10);
            end;
           end;
      end; {case}
      if (smessage[1] = 'x') then Server_Disconnect(s );
    end;
    count := count + 1;
    if (count > 100) then Server_disconnect(s);
   end;

begin
  writeln('Turbo Pascal for Windows WINSOCK demo');
  portnumber := 23;
  MTU_MAX := 1500;
  hostname := 'aa6ed.ampr.org';
  s := open_client('aa6ed.ampr.org',portnumber);
  do_keyboard(s);
  WSACleanup;
  writeln('Finished...');
end.